/*
 * Copyright (c) 2007 NTT DATA Corporation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package jp.terasoluna.rich.functionsample.dbmessage.service;

import java.util.Locale;
import org.springframework.context.NoSuchMessageException;
import jp.terasoluna.fw.dao.QueryDAO;
import jp.terasoluna.fw.dao.UpdateDAO;
import jp.terasoluna.fw.service.rich.exception.ServiceException;
import jp.terasoluna.fw.web.rich.context.support.RequestContextSupport;
import jp.terasoluna.rich.functionsample.common.context.support.RequestContextSupportImpl;
import jp.terasoluna.rich.functionsample.common.messages.DBMessageAccessor;
import jp.terasoluna.rich.functionsample.common.messages.ReloadDataSourceMessage;
import jp.terasoluna.rich.functionsample.dbmessage.bean.DBMessageInputData;
import jp.terasoluna.rich.functionsample.dbmessage.bean.DBMessageResultData;
import jp.terasoluna.rich.functionsample.dbmessage.bean.MessageVO;

/**
 * DBメッセージ取得サービ実装クラス
 *
 */
public class DBMessageServiceImpl implements DBMessageService {
    
    /**
     * 制御情報を扱うクラス
     */
    protected RequestContextSupport ctxSupport = null;
    
    /**
     * DBメッセージ管理のメッセージ取得クラス
     */
    protected DBMessageAccessor msgAcc = null;
    
    /**
     * DBメッセージ管理のメッセージ再定義クラス
     */
    protected ReloadDataSourceMessage reloader = null;

    /**
     * 取得用DAOクラス。
     * Springによりインスタンス生成され設定される。
     */
    protected QueryDAO queryDAO = null;
    
    /**
     * 更新用DAOクラス。
     * Springによりインスタンス生成され設定される。
     */
    protected UpdateDAO updateDAO = null;

    /**
     * メッセージを取得する。<br>
     * 1. 制御情報を扱うクラスから言語、国、方言を取得する。<br>
     * 2. 言語、国、方言によるロケールを設定する。<br>
     * 3. 入力文字列がmessageの場合にメッセージを取得する。<br>
     * 4. 入力文字列がreloadの場合にメッセージを再定義してメッセージを取得する。<br>
     * 5. 入力文字列がmessageとreloadの以外は例外をスローする。
     *
     * @param params 入力クラス
     * @return 結果クラス
     * @throws Exception 例外発生時
     */
    public DBMessageResultData getMessage(DBMessageInputData params) 
                                                    throws Exception {
        
        DBMessageResultData result = new DBMessageResultData();
        
        //ロケール情報を制御情報クラスから取得
        String language = (String) ctxSupport.getProperty(
                RequestContextSupportImpl.LANGUAGE_KEY);
        String country =
            (String) ctxSupport.getProperty(RequestContextSupportImpl.COUNTRY_KEY);
        String variant =
            (String) ctxSupport.getProperty(RequestContextSupportImpl.VARIANT_KEY);
        
        //ロケールクラス生成
        Locale locale = new Locale(language, country, variant);
        
        // 処理種類がmessageの場合、メッセージを取得する。
        // reloadの場合、メッセージを再定義してメッセージを取得する。
        // その他の場合、例外処理する。
        if (params.getContent().equals("message")) {
            try {
            result.setMessage(
                    msgAcc.getMessage(params.getMessageKey(), locale));
            } catch (NoSuchMessageException e) {
                //入力されたメッセージキーに対して入力されたロケールと
                //デフォルトロケールでメッセージが存在しない場合、エラーを返す。
                throw new ServiceException("errors.UC110.00001");
            }
        } else if (params.getContent().equals("reload")) {
            
            //現在のロケールに当たるメッセージ情報クラスを生成する。
            MessageVO replaceMessageVO = new MessageVO();
            replaceMessageVO.setCode(params.getMessageKey());
            replaceMessageVO.setLanguages(language);
            replaceMessageVO.setContry(country);
            replaceMessageVO.setVariant(variant);
            
            //DBから現在設定されているメッセージ情報を取得
            MessageVO messageVO = queryDAO.executeForObject(
                    "getMessage", replaceMessageVO, MessageVO.class);
            
            //DBに存在しないメッセージの場合はエラーを返す。
            if (messageVO == null) {
                throw new ServiceException("errors.UC110.00001");
            }
            
            //新しいメッセージを設定する。
            replaceMessageVO.setMessage("変更されたメッセージです。");
            replaceMessageVO.setId(messageVO.getId());
            
            //新しいメッセージをDBに反映する
            updateDAO.execute("updateMessage", replaceMessageVO);
            
            //リロード処理を行う。
            reloader.reloadDataSource();
            
            //リロードされたメッセージリソースからメッセージを取得
            result.setMessage(
                    msgAcc.getMessage(params.getMessageKey(), locale));
            
            //DBのメッセージ情報を基に戻す。
            updateDAO.execute("updateMessage", messageVO);
            reloader.reloadDataSource();
        } else {
            //処理種類がmessage、reload以外の場合はエラーを返す。
            throw new ServiceException("errors.UC110.00002");
        }
        return result;
    }

    /**
     * 制御情報を扱うクラスを設定する。
     * @param ctxSupport 制御情報を扱うクラス
     */
    public void setCtxSupport(RequestContextSupport ctxSupport) {
        this.ctxSupport = ctxSupport;
    }
    
    /**
     * DBメッセージ管理のメッセージ取得クラスを設定する。
     * @param msgAcc DBメッセージ管理のメッセージ取得クラス
     */
    public void setMsgAcc(DBMessageAccessor msgAcc) {
        this.msgAcc = msgAcc;
    }

    /**
     * DBメッセージ管理のメッセージ再定義クラスを設定する。
     * @param reloader DBメッセージ管理のメッセージ再定義クラス
     */
    public void setReloader(ReloadDataSourceMessage reloader) {
        this.reloader = reloader;
    }
    
    /**
     * queryDAOを設定する。
     * @param queryDAO queryDAO
     */
    public void setQueryDAO(QueryDAO queryDAO) {
        this.queryDAO = queryDAO;
    }

    /**
     * updateDAOを設定する。
     * @param updateDAO updateDAO。
     */
    public void setUpdateDAO(UpdateDAO updateDAO) {
        this.updateDAO = updateDAO;
    }
}
